/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Metodos_Ordenacion;

import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

/**
 *
 * @author Usuario iTC
 */
public class Comparacion extends javax.swing.JFrame {

    /**
     * Creates new form Comparacion
     */
    String elementos = "";
    Vector arreglo = new Vector();
    long tiempo;
    long tiempo2;
    /////////////////////
    long inicio;
    long inicio2;
    String cadena = "";
    int A[];
    boolean pasada1 = true;
    int cont = 1;
    List<Integer> lista = new ArrayList<Integer>();
    String presentar;
    String solucion = "";

    public Comparacion() {
        initComponents();
        setLocationRelativeTo(null);

        setIconImage(new ImageIcon(getClass().getResource("/fotos/icono.jpg")).getImage());//PONER UN ICONO
        ((JPanel) getContentPane()).setOpaque(false);
        ImageIcon uno = new ImageIcon(this.getClass().getResource("/fotos/ci.jpeg"));
        JLabel fondo = new JLabel();
        fondo.setIcon(uno);
        getLayeredPane().add(fondo, JLayeredPane.FRAME_CONTENT_LAYER);
        fondo.setBounds(0, 0, uno.getIconWidth(), uno.getIconHeight());

        setVisible(true);

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jComboBox1 = new javax.swing.JComboBox<>();
        jComboBox2 = new javax.swing.JComboBox<>();
        botoncomparar = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        txtelemento = new javax.swing.JTextField();
        botonIngresar = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        txtVector = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        txtnanoUNO = new javax.swing.JTextField();
        txtnanoDOS = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        botonNUEVO = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("COMPARACIÓN");

        jComboBox1.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Metodo_Intercambio", "Metodo_Quicksort", "Metodo_por_Seleccion", "Metodo_Shell", "Metodo_Burbuja" }));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBox1ActionPerformed(evt);
            }
        });

        jComboBox2.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Metodo_Intercambio", "Metodo_Quicksort", "Metodo_por_Seleccion", "Metodo_Shell", "Metodo_Burbuja" }));

        botoncomparar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Scales_24px_1.png"))); // NOI18N
        botoncomparar.setText("Comparar");
        botoncomparar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botoncompararActionPerformed(evt);
            }
        });

        jLabel1.setText("Ingrese el elmento: ");

        botonIngresar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Cancel_Last_Digit_24px.png"))); // NOI18N
        botonIngresar.setText("Ingresar");
        botonIngresar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonIngresarActionPerformed(evt);
            }
        });

        jLabel2.setText("Datos del Vector:");

        txtVector.setEditable(false);

        jLabel3.setText("VS");

        jLabel4.setText("1)");

        jLabel5.setText("2)");

        txtnanoUNO.setEditable(false);

        txtnanoDOS.setEditable(false);

        jLabel6.setText("1)");

        jLabel7.setText("2)");

        jLabel8.setText("Tiempo de ejecucion (nanosegundos)");

        botonNUEVO.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Wipes_24px.png"))); // NOI18N
        botonNUEVO.setText("Nuevo");
        botonNUEVO.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonNUEVOActionPerformed(evt);
            }
        });

        jButton3.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fotos/icons8_Unavailable_24px.png"))); // NOI18N
        jButton3.setText("SALIR");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(40, 40, 40)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addGap(5, 5, 5)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, 225, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 78, Short.MAX_VALUE)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(jLabel3)
                                        .addGap(38, 38, 38)
                                        .addComponent(jLabel5)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, 225, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                                        .addComponent(botonNUEVO)
                                        .addGap(18, 18, 18)
                                        .addComponent(jButton3)))
                                .addGap(39, 39, 39))
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel1)
                                    .addComponent(jLabel2))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addGroup(layout.createSequentialGroup()
                                        .addComponent(txtelemento, javax.swing.GroupLayout.PREFERRED_SIZE, 53, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(47, 47, 47)
                                        .addComponent(botonIngresar))
                                    .addComponent(txtVector, javax.swing.GroupLayout.PREFERRED_SIZE, 191, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(botoncomparar)
                                .addGap(82, 82, 82))))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel6, javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel7, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(txtnanoDOS, javax.swing.GroupLayout.DEFAULT_SIZE, 308, Short.MAX_VALUE)
                                    .addComponent(txtnanoUNO))
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel8)
                                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(43, 43, 43)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtelemento, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(botonIngresar)
                    .addComponent(botoncomparar))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(txtVector, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(16, 16, 16)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jComboBox2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(jLabel5)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 27, Short.MAX_VALUE)
                .addComponent(jLabel8)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtnanoUNO, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel6))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(txtnanoDOS, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel7))
                        .addGap(35, 35, 35))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(botonNUEVO)
                            .addComponent(jButton3))
                        .addGap(24, 24, 24))))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void botonIngresarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonIngresarActionPerformed
        // TODO add your handling code here:
        elementos += txtelemento.getText();

        cadena += this.txtelemento.getText();
        ;

        Integer elemento = Integer.parseInt(txtelemento.getText());
        txtelemento.requestFocus();
        ///////////

        ///////////
        arreglo.add(elemento);
        txtVector.setText(arreglo + " ");
        txtelemento.setText("");
        System.out.println(elementos);
    }//GEN-LAST:event_botonIngresarActionPerformed

    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBox1ActionPerformed
        // TODO add your handling code here:


    }//GEN-LAST:event_jComboBox1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        Principal a = new Principal();
        a.setVisible(true);

        hide();
    }//GEN-LAST:event_jButton3ActionPerformed

    private void botoncompararActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botoncompararActionPerformed
        // TODO add your handling code here:
        int a, b;
        a = jComboBox1.getSelectedIndex();
        b = jComboBox2.getSelectedIndex();
        if (arreglo.isEmpty() || a==b) {
            JOptionPane.showMessageDialog(this, "La operacion no se puede ralizar:"+"\n" +
                    "- El vector se encuentra vacio"+"\n"+
                    "- No se puede comparar metodos iguales");

        } else {

            System.out.println("AAAAAAAAAAAAAAAAAAAAAAAAAA             " + a);
            System.out.println("BBBBBBBBBBBBBBBBBBBBBBBBBB                  " + b);

            switch (a) {
                /////////////////////////////////////////////
                case 0:
                    System.out.println("METODO INTERCAMBIO                         1");
                    long inc = System.nanoTime();
                    Vector<Integer> elementosOrdenados = new Vector();
                    elementosOrdenados.addAll(arreglo);

                    for (int i = 0; i < arreglo.size() - 1; i++) {

                        for (int j = i + 1; j < arreglo.size(); j++) {

                            Vector vp = new Vector();
                            if (elementosOrdenados.get(i) > elementosOrdenados.get(j)) {
                                Integer aux = elementosOrdenados.get(j);
                                elementosOrdenados.set(j, elementosOrdenados.get(i));
                                elementosOrdenados.set(i, aux);

                            }
                            for (int k = 0; k < elementosOrdenados.size(); k++) {
                                vp.add(elementosOrdenados.get(k));

                            }

                        }

                    }
                    System.out.println(elementosOrdenados);

                    long fin = System.nanoTime();
                    long timpo = fin - inc;
                    tiempo = timpo;
                    txtnanoUNO.setText(tiempo + "");
                    System.out.println("tiempo UNO" + tiempo);
                    break;
                ////////////////////////////////////

                case 1:
                    System.out.println("METODO QUICSHORT                    1");
                    inc = System.nanoTime();

                    presentar = "";
                    cont = 1;
                    pasada1 = true;

                    inicio = System.nanoTime();
                    inicio2 = System.nanoTime();

                    A = new int[cadena.length()];
                    System.out.println(cadena);
                    System.out.println(cadena.length());
                    for (int i = 0; i < cadena.length(); i++) {
                        String d = Character.toString(cadena.charAt(i));
                        A[i] = Integer.parseInt(d);

                    }

                    System.out.println(solucion);

                    quickShort(A, 0, A.length - 1);

                    mostrar(A);
                    fin = System.nanoTime();
                    timpo = fin - inc;
                    tiempo = timpo;
                    txtnanoUNO.setText(tiempo + "");
                    System.out.println("tiempo UNO" + tiempo);
                    break;

                case 2:
/////////////////////////////
                    System.out.println("METODO POR SELECCION                     1");
                    inc = System.nanoTime();
                    Vector<Integer> va = new Vector();
                    va.addAll(arreglo);

                    for (int i = 0; i < va.size() - 1; i++) {
                        Integer menor = va.get(i);
                        Integer indice = i;

                        for (int j = i + 1; j < va.size(); j++) {
                            if (va.get(j) < menor) {
                                menor = va.get(j);
                                indice = j;

                            }

                        }

                        va.set(indice, va.get(i));
                        va.set(i, menor);
                        Vector vp = new Vector();
                        for (int k = 0; k < va.size(); k++) {
                            vp.add(va.get(k));

                        }

                    }

                    fin = System.nanoTime();
                    timpo = fin - inc;

                    txtnanoUNO.setText(timpo + "");
                    System.out.println("tiempo UNO" + tiempo);
                    break;

                case 3:
                    System.out.println("METODO SHELL                  1");
                    ///////////////////////
                    inc = System.nanoTime();

                    Vector presentar = new Vector();
                    Integer A[];
                    A = new Integer[cadena.length()];
                    System.out.println(cadena
                    );
                    System.out.println(cadena.length());

                    for (int i = 0; i < cadena.length(); i++) {
                        String d = Character.toString(cadena.charAt(i));
                        A[i] = Integer.parseInt(d);

                    }

                    int salto,
                     aux,
                     i,
                     tamaño,
                     cont = 1;

                    boolean cambios;
                    for (salto = A.length / 2; salto != 0; salto /= 2) {
                        cambios = true;
                        while (cambios) { // Mientras se intercambie algún elemento
                            cambios = false;
                            for (i = salto; i < A.length; i++) // se da una pasada
                            {

                                if (A[i - salto] > A[i]) { // y si están desordenados
                                    presentar.add("Pasada " + (cont));
                                    presentar.add("\n");
                                    presentar.add("______________");
                                    cont++;
                                    presentar.add("\n");

                                    String cadenita = " ";
                                    for (int h = 0; h < A.length; h++) {
                                        System.out.print(A[h]);
                                        cadenita += A[h];
                                    }
                                    presentar.add(cadenita);
                                    presentar.add("\n");

                                    aux = A[i]; // se reordenan
                                    A[i] = A[i - salto];
                                    A[i - salto] = aux;
                                    cambios = true; // y se marca como cambio.
                                }
                            }
                        }
                    }

                    arreglo.removeAll(arreglo);
                    for (int h = 0; h < A.length; h++) {
                        arreglo.add(A[h]);
                    }

                    fin = System.nanoTime();

                    double NANOSEGUNDOS = (double) (fin - inc);
                    System.out.println(arreglo);
                    System.out.println("tiempo UNO" + NANOSEGUNDOS);

                case 4:
                    System.out.println("METODO BURBUJA                1");
                    /////////////////////////////
                    inc = System.nanoTime();

                    Vector<Integer> ordenarElementos = new Vector();
                    ordenarElementos.addAll(arreglo);

                    for (int h = 0; h < arreglo.size() - 1; h++) {

                        for (int j = 0; j < arreglo.size() - h - 1; j++) {
                            Vector vProceso = new Vector();
                            if (ordenarElementos.get(j) > ordenarElementos.get(j + 1)) {
                                aux = ordenarElementos.get(j);
                                ordenarElementos.set(j, ordenarElementos.get(j + 1));
                                ordenarElementos.set(j + 1, aux);
                            }
                            for (int k = 0; k < ordenarElementos.size(); k++) {
                                vProceso.add(ordenarElementos.get(k));
                            }

                        }

                    }
                    fin = System.nanoTime();
                    timpo = fin - inc;
                    System.out.println(ordenarElementos);

                    txtnanoUNO.setText(timpo + "");
                    System.out.println("tiempo UNO" + timpo);
                    break;

            }
            ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            switch (b) {
                /////////////////////////////////////////////
                case 0:
                    System.out.println("METODO POR INTERCAMBIO                2");
                    long inc = System.nanoTime();
                    Vector<Integer> elementosOrdenados = new Vector();
                    elementosOrdenados.addAll(arreglo);

                    for (int i = 0; i < arreglo.size() - 1; i++) {

                        for (int j = i + 1; j < arreglo.size(); j++) {

                            Vector vp = new Vector();
                            if (elementosOrdenados.get(i) > elementosOrdenados.get(j)) {
                                Integer aux = elementosOrdenados.get(j);
                                elementosOrdenados.set(j, elementosOrdenados.get(i));
                                elementosOrdenados.set(i, aux);

                            }
                            for (int k = 0; k < elementosOrdenados.size(); k++) {
                                vp.add(elementosOrdenados.get(k));

                            }

                        }

                    }
                    System.out.println(elementosOrdenados);

                    long fin = System.nanoTime();
                    long timpo = fin - inc;
                    tiempo = timpo;
                    txtnanoDOS.setText(tiempo + "");
                    System.out.println("tiempo DOS" + tiempo);
                    break;
                ////////////////////////////////////

                case 1:
                    System.out.println("METODO QUICSHORT              2");
                    inc = System.nanoTime();

                    presentar = "";
                    cont = 1;
                    pasada1 = true;

                    inicio2 = System.nanoTime();

                    A = new int[cadena.length()];
                    System.out.println(cadena);
                    System.out.println(cadena.length());
                    for (int i = 0; i < cadena.length(); i++) {
                        String d = Character.toString(cadena.charAt(i));
                        A[i] = Integer.parseInt(d);

                    }

                    System.out.println(solucion);

                    quickShort(A, 0, A.length - 1);

                    mostrar(A);
                    fin = System.nanoTime();
                    timpo = fin - inc;
                    tiempo = timpo;
                    txtnanoDOS.setText(tiempo + "");
                    System.out.println("tiempo DOS" + tiempo);
                    break;

                case 2:
/////////////////////////////
                    System.out.println("METODO POR SELECCION          2");
                    inc = System.nanoTime();
                    Vector<Integer> va = new Vector();
                    va.addAll(arreglo);

                    for (int i = 0; i < va.size() - 1; i++) {
                        Integer menor = va.get(i);
                        Integer indice = i;

                        for (int j = i + 1; j < va.size(); j++) {
                            if (va.get(j) < menor) {
                                menor = va.get(j);
                                indice = j;

                            }

                        }

                        va.set(indice, va.get(i));
                        va.set(i, menor);
                        Vector vp = new Vector();
                        for (int k = 0; k < va.size(); k++) {
                            vp.add(va.get(k));

                        }

                    }

                    fin = System.nanoTime();
                    timpo = fin - inc;

                    txtnanoDOS.setText(timpo + "");
                    System.out.println("tiempo DOS" + timpo);
                    break;

                case 3:
                    System.out.println("METODO SHELL             2");
                    ///////////////////////
                    inc = System.nanoTime();

                    Vector presentar = new Vector();
                    Integer A[];
                    A = new Integer[cadena.length()];
                    System.out.println(cadena
                    );
                    System.out.println(cadena.length());

                    for (int i = 0; i < cadena.length(); i++) {
                        String d = Character.toString(cadena.charAt(i));
                        A[i] = Integer.parseInt(d);

                    }

                    int salto,
                     aux,
                     i,
                     tamaño,
                     cont = 1;

                    boolean cambios;
                    for (salto = A.length / 2; salto != 0; salto /= 2) {
                        cambios = true;
                        while (cambios) { // Mientras se intercambie algún elemento
                            cambios = false;
                            for (i = salto; i < A.length; i++) // se da una pasada
                            {

                                if (A[i - salto] > A[i]) { // y si están desordenados
                                    presentar.add("Pasada " + (cont));
                                    presentar.add("\n");
                                    presentar.add("______________");
                                    cont++;
                                    presentar.add("\n");

                                    String cadenita = " ";
                                    for (int h = 0; h < A.length; h++) {
                                        System.out.print(A[h]);
                                        cadenita += A[h];
                                    }
                                    presentar.add(cadenita);
                                    presentar.add("\n");

                                    aux = A[i]; // se reordenan
                                    A[i] = A[i - salto];
                                    A[i - salto] = aux;
                                    cambios = true; // y se marca como cambio.
                                }
                            }
                        }
                    }

                    arreglo.removeAll(arreglo);
                    for (int h = 0; h < A.length; h++) {
                        arreglo.add(A[h]);
                    }

                    fin = System.nanoTime();

                    double NANOSEGUNDOS = (double) (fin - inc);
                    System.out.println(arreglo);

                    System.out.println(NANOSEGUNDOS);
                    txtnanoDOS.setText(NANOSEGUNDOS + "");
                    System.out.println("tiempo DOS" + NANOSEGUNDOS);
                    break;

                case 4:
                    System.out.println("METODO BURBUJA        2");
                    /////////////////////////////
                    inc = System.nanoTime();

                    Vector<Integer> ordenarElementos = new Vector();
                    ordenarElementos.addAll(arreglo);

                    for (int h = 0; h < arreglo.size() - 1; h++) {

                        for (int j = 0; j < arreglo.size() - h - 1; j++) {
                            Vector vProceso = new Vector();
                            if (ordenarElementos.get(j) > ordenarElementos.get(j + 1)) {
                                aux = ordenarElementos.get(j);
                                ordenarElementos.set(j, ordenarElementos.get(j + 1));
                                ordenarElementos.set(j + 1, aux);
                            }
                            for (int k = 0; k < ordenarElementos.size(); k++) {
                                vProceso.add(ordenarElementos.get(k));
                            }

                        }

                    }
                    fin = System.nanoTime();
                    timpo = fin - inc;
                    System.out.println(ordenarElementos);

                    txtnanoDOS.setText(timpo + "");
                    System.out.println("tiempo DOS" + timpo);
                    break;

            }

        }
    }//GEN-LAST:event_botoncompararActionPerformed

    private void botonNUEVOActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonNUEVOActionPerformed
        // TODO add your handling code here:
        elementos = "";
        cadena = "";
        arreglo.clear();
        txtVector.setText("");
        txtelemento.setText("");
        txtnanoDOS.setText("");
        txtnanoUNO.setText("");


    }//GEN-LAST:event_botonNUEVOActionPerformed
    public void quickShort(int[] arreglo, int inicio, int fin) {

        if (pasada1) {
            presentar = presentar.concat("\n");
            System.out.println("\nPasada 1");
            presentar = presentar.concat("Pasada 1");
        }

        int i = inicio;// i avanza en el arreglo hacia la derecha
        int j = fin;// j avanza en el arreglo hacia la izquierda
        int pivote = arreglo[(inicio + fin) / 2];

        do {
            while (arreglo[i] < pivote) {

                i++; // Si ya esta ordenado incrementa
            }
            while (arreglo[j] > pivote) {

                j--; //Si ya esta ordenado decrementa
            }

            if (i <= j) {

                int aux = arreglo[i];
                arreglo[i] = arreglo[j];
                arreglo[j] = aux;
                i++;
                j--;
            }

            for (int k = 0; k < arreglo.length; k++) {
                int valor = arreglo[k];
                lista.add(valor);
            }
            int cont = 0;
            //
            for (int k = 0; k < lista.size() - 1; k++) {
                if (lista.get(k) <= lista.get(k + 1)) {
                    cont++;
                }
            }
//
            if (lista.size() == arreglo.length) {
                if (cont == lista.size() - 1) {

                    System.out.println(lista);
                    presentar = presentar.concat("\n");
                    presentar = presentar.concat(lista + "");
                    presentar = presentar.concat("\n");
                    cont = 0;
                    return;
                } else {
                    if (cont == 0) {
                        return;
                    } else {
                        presentar = presentar.concat("\n");

                        System.out.println(lista + " holaaaaa");
                        presentar = presentar.concat(lista + "");
                        presentar = presentar.concat("\n");
                        lista.clear();
                    }
                }

            }

        } while (i <= j);

        pasada1 = false;
        this.cont++;
        if (inicio < j) {
            presentar = presentar.concat("Pasada " + (cont));
            presentar = presentar.concat("\n");
            presentar = presentar.concat("______________");
            System.out.println("\nPasada " + cont);
            quickShort(arreglo, inicio, j); //recursividad
            presentar = presentar.concat("\n");

        }
        if (i < fin) {
            presentar = presentar.concat("Pasada " + (cont));
            presentar = presentar.concat("\n");
            presentar = presentar.concat("______________");
            System.out.println("\nPasada " + cont);
            quickShort(arreglo, i, fin);    //recursividad
            presentar = presentar.concat("\n");

        }

    }

    public void mostrar(int[] arreglo) {

        for (int i = 0; i < arreglo.length; i++) {

            System.out.print(arreglo[i] + " ");
            solucion += arreglo[i];

        }

        long fin2 = System.nanoTime();

        double NANOSEGUNDOS = (fin2 - inicio2);

    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(Comparacion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(Comparacion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(Comparacion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(Comparacion.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Comparacion().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonIngresar;
    private javax.swing.JButton botonNUEVO;
    private javax.swing.JButton botoncomparar;
    private javax.swing.JButton jButton3;
    private javax.swing.JComboBox<String> jComboBox1;
    private javax.swing.JComboBox<String> jComboBox2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JTextField txtVector;
    private javax.swing.JTextField txtelemento;
    private javax.swing.JTextField txtnanoDOS;
    private javax.swing.JTextField txtnanoUNO;
    // End of variables declaration//GEN-END:variables
}
